# Interface IfcMetadata

Defines strongly typed metadata for IFC files.

interface IfcMetadata {
classes?: string[];
floors?: IfcFloor[];
hasParseError: boolean;
header?: { schemas?: string[] };
parserVersion?: VersionInfo;
sites?: IfcSiteInformation[];
statistics?: {
diagnostics?: {
error?: number;
information?: number;
warning?: number;
};
productCount?: number;
};
status: | "Unknown"
| "Processing"
| "Processed"
| "Failed"
| "NotSupported"
| "Timeout"
| "MemoryLimitExceeded"
| "Fatal";
topIfcLocalPlacementTransform?: BimTransform & { distanceToOrigo: number };
url: {
geom?: string;
"geom-feat"?: string;
idx?: string;
prop?: string;
t8gd?: string;
};
}

#### Hierarchy (View Summary)

- TwinfinityParserMetadata
  - IfcMetadata

##### Index

### Properties

classes?
floors?
hasParseError
header?
parserVersion?
sites?
statistics?
status
topIfcLocalPlacementTransform?
url

## Properties

### `Optional` `Readonly` classes

classes?: string[]

List of IFC classes available in IFC file

### `Optional` `Readonly` floors

floors?: IfcFloor[]

List of floors (storey levels) available in IFC file

### `Readonly` hasParseError

hasParseError: boolean

Set to `true` if the change has not been parsed correctly. For example if this happens for a .ifc or a .dwg file then it will not be possible to load the file.

Inherited from TwinfinityParserMetadata.hasParseError

### `Optional` header

header?: { schemas?: string[] }

header

#### Type declaration

- ##### `Optional` schemas?: string[]

  The schema(s) declared in the IFC file.

### `Optional` `Readonly` parserVersion

parserVersion?: VersionInfo

Version of the parser that parsed this IFC file. Useful when we load IFC files which was parsed with old parsers to keep backwards compatibility. May be undefined if file was parsed before this property was introduced.

### `Optional` `Readonly` sites

sites?: IfcSiteInformation[]

List of sites in IFC file

### `Optional` `Readonly` statistics

statistics?: {
diagnostics?: { error?: number; information?: number; warning?: number };
productCount?: number;
}

Statistics of IFC file

#### Type declaration

- ##### `Optional` `Readonly` diagnostics?: { error?: number; information?: number; warning?: number }

  Number of issues encountered while processing the IFC file.

  - ##### `Optional` `Readonly` error?: number

    Number of error diagnostics made during file processing

  - ##### `Optional` `Readonly` information?: number

    Number of informational diagnostics made during file processing

  - ##### `Optional` `Readonly` warning?: number

    Number of warning diagnostics made during file processing

- ##### `Optional` `Readonly` productCount?: number

  Number of products in IFC file.

### status

status:
| "Unknown"
| "Processing"
| "Processed"
| "Failed"
| "NotSupported"
| "Timeout"
| "MemoryLimitExceeded"
| "Fatal"

Indicates outcome of how the system processed, has not yet processed or is processing the IFC file.

Inherited from TwinfinityParserMetadata.status

### `Optional` `Readonly` topIfcLocalPlacementTransform

topIfcLocalPlacementTransform?: BimTransform & { distanceToOrigo: number }

The transform of the topmost IfcLocalPlacement node in the IFC file. This tells us how the overall model is rotated, scaled and translated. Often very useful when determining why two IFC files do not align properly. One can often see that the translation or rotation part differs in those cases. The transform is expressed in meters.

#### Type declaration

- ##### `Readonly` distanceToOrigo: number

  Distance to origo for topmost IfcLocalPlacement node.

### `Readonly` url

url: {
geom?: string;
"geom-feat"?: string;
idx?: string;
prop?: string;
t8gd?: string;
}

URLs for blobs containing IFC data.

#### Type declaration

- ##### `Optional` `Readonly` geom?: string

  URL to IFC geometry file (needed for any 3D visualizations)

- ##### `Optional` `Readonly` geom-feat?: string

  URL to IFC geometric features file

- ##### `Optional` `Readonly` idx?: string

  URL to IFC index file (contains IFC product hierarchy)

- ##### `Optional` `Readonly` prop?: string

  URL to IFC property set file.

- ##### `Optional` `Readonly` t8gd?: string

  URL to IFC geometry v2 file (needed for any 3D visualizations)